      DOUBLE PRECISION FUNCTION betacn(a,b,x,iwhich)
      IMPLICIT DOUBLE PRECISION (a-h,o-p,r-z),INTEGER (i-n),LOGICAL (q)
C**********************************************************************
C
C      DOUBLE PRECISION FUNCTION BETACN(A,B,X,IWHICH)
C               BETA CoNstants
C
C     Computes the constants needed for the cumulative beta.  Were neste
C     procedures allowed in Fortran, this would be nested in CUMBET.
C
C
C                              Function
C
C
C     If IWHICH .EQ. 1
C     RETURNS:
C          A*LOG(X) + (B-1)*LOG(1-X) - DLNBET( A, B ) - LOG(A)
C
C     If IWHICH .EQ. 2
C     RETURNS:
C          A*LOG(X) + B*LOG(1-X) - DLNBET( A, B ) - LOG(A)
C
C**********************************************************************

C     .. Scalar Arguments ..
      DOUBLE PRECISION a,b,x
      INTEGER iwhich
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION alcon,alconr,alncon,aold,bold,temp,z
      LOGICAL qrevrs,qsame
C     ..
C     .. External Functions ..
      DOUBLE PRECISION dln1mx,dlnbet
      EXTERNAL dln1mx,dlnbet
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC log
C     ..
C     .. Save statement ..
      SAVE aold,bold,alcon,alconr
C     ..
C     .. Data statements ..
      DATA aold/-1.0D0/,bold/-1.0D0/
C     ..
C     .. Executable Statements ..

      qsame = aold .EQ. a .AND. bold .EQ. b
      qrevrs = aold .EQ. b .AND. bold .EQ. a
      IF (qsame) THEN
          alncon = alcon

      ELSE IF (qrevrs) THEN
          alncon = alconr

      ELSE
          qsame = .TRUE.
          temp = dlnbet(a,b)
          alcon = -temp - log(a)
          alconr = -temp - log(b)
          alncon = alcon
          aold = a
          bold = b
      END IF

      IF (.NOT. (x.GT.0.1D0)) GO TO 10
      z = log(1.0D0-x)
      GO TO 20

   10 z = dln1mx(x)
   20 IF (.NOT. (iwhich.EQ.1)) GO TO 30
      betacn = a*log(x) + (b-1.0D0)*z + alncon
      GO TO 40

   30 betacn = a*log(x) + b*z + alncon
   40 RETURN

      END
