      Real*8 FUNCTION binden(ns,n,p)
C**********************************************************************
C
C     Real*8 FUNCTION BINDEN(NS,N,P)
C                     BINomial DENsity function
C
C
C                              Function
C
C
C     Returns the probability of NS successes in N binomial trials,
C     each of which has probability P of success.
C
C
C                              Arguments
C
C
C     NS      --> Number of successes for which binomial density
C                 is calculated.
C                                         NS is INTEGER
C
C     N       --> Number of trials
C                                         N is INTEGER
C
C     P       --> Probability of success on each binomial trial.
C					  P is Real*8
C
C**********************************************************************
C
C
C                              Variables
C
C
      Real*8 bicoef
      Real*8 nlfact,slfact,nmslfc
      DOUBLE PRECISION xlfact
C**********************************************************************
C
C     BICOEF  --> Binomial coefficient C(N,NS)
C
C     NLFACT  --> LOG(N!), calculated by XLFACT
C
C     SLFACT  --> LOG(NS!), calculated by XLFACT
C
C     NMSLFC  --> LOG((N-NS)!), calculated by XLFACT
C
C     XLFACT  --> returns the log of the factorial of its argument
C
C**********************************************************************
C
C
C *** Main body of program
C
      nlfact = xlfact(n)
      slfact = xlfact(ns)
      nmslfc = xlfact(n-ns)
C
      bicoef = exp(nlfact- (slfact+nmslfc))
C
      !binden = bicoef* (p**real(ns))* ((1.0-p)**real(n-ns))
      binden = bicoef* (p**dfloat(ns))* ((1.0D0-p)**dfloat(n-ns))
C
      RETURN

      END
