










                                     CDFLIB

            Library of Fortran Routines for Cumulative Distribution
                 Functions, Inverses, and Other Parameters

                               (June, 1993)






                    Summary Documentation of Each Routine








                            Compiled and Written by:

                                 Barry W. Brown
                                  James Lovato
                                   









                     Department of Biomathematics, Box 237
                     The University of Texas, M.D. Anderson Cancer Center
                     1515 Holcombe Boulevard
                     Houston, TX      77030


 This work was supported by grant CA-16672 from the National Cancer Institute.


WHICH and STATUS are integer; all other arguments are Real.

DISTRIBUTION                 INPUT RANGE                   SEARCH RANGE


-------------------- Beta 

      SUBROUTINE CDFBET( WHICH, P, X, A, B, STATUS, BOUND )

P                            [0,1]                         -----------
X                            [0,1]                         [0,1]
A                            (0,infinity)                  [1E-30,1E30]
B                            (0,infinity)                  [1E-30,1E30]

-------------------- Binomial

      SUBROUTINE CDFBIN ( WHICH, P, S, XN, PR, STATUS, BOUND )

P                            [0,1]                         -----------
S                            [0,XN]                        [0,XN]
XN                           (0,infinity)                  [1E-30,1E30]
PR                           [0,1]                         [0,1]

-------------------- Chi-square

      SUBROUTINE CDFCHI( WHICH, P, X, DF, STATUS, BOUND )

P                            [0,1E-7)                      -----------
X                            [0,infinity]                  [0,1E30]
DF                           (0,infinity)                  [1E-30,1E30]

-------------------- Noncentral Chi-square

      SUBROUTINE CDFCHN( WHICH, P, X, DF, PNONC, STATUS, BOUND )

P                            [0,1E-7)                      -----------
X                            [0,infinity]                  [0,1E30]
DF                           (0,infinity)                  [1E-30,1E30]
PNONC                        [0,infinity)                  [0,1E4]

-------------------- F


      SUBROUTINE CDFF( WHICH, P, F, DFN, DFD, STATUS, BOUND )

P                            [0,1E-7)                      -----------
F                            [0,infinity)                  [0,1E30]
DFN                          (0,infinity)                  [1E-30,1E30]
DFD                          (0,infinity)                  [1E-30,1E30]

-------------------- Noncentral F

      SUBROUTINE CDFFNC( WHICH, P, F, DFN, DFD, PNONC, STATUS, BOUND )

P                            [0,1E-7)                      -----------
F                            [0,infinity)                  [0,1E30]
DFN                          (0,infinity)                  [1E-30,1E30]
DFD                          (0,infinity)                  [1E-30,1E30]
PNONC                        [0,infinity)                  [0,1E4]

-------------------- Gamma

      SUBROUTINE CDFGAM( WHICH, P, X, SHAPE, SCALE, STATUS, BOUND )

P                            [0,1-E-7)                      -----------
X                            [0,infinity)                  [0,1E30]
SHAPE                        (0,infinity)                  [1E-30,1E30]
SCALE                        (0,infinity)                  [1E-30,1E30]

-------------------- Negative Binomial

      SUBROUTINE CDFNBN ( WHICH, P, S, XN, PR, STATUS, BOUND )

P                            [0,1E-7)                      -----------
S                            [0,infinity)                  [0,1E30]
XN                           [0,infinity)                  [0,1E30]
PR                           [0,1]                         [0,1]

-------------------- Normal

      SUBROUTINE CDFNOR( WHICH, P, X, MEAN, SD )

P                            [1E-7,1-E-7]                  -----------
X                            (-infinity,infinity)          -----------
MEAN                         (-infinity,infinity)          -----------
SD                           (0,infinity)                  -----------

-------------------- Poisson

      SUBROUTINE CDFPOI( WHICH, P, S, XLAM, STATUS, BOUND )

P                            [0,1-E-7)                      -----------
S                            [0,infinity)                  [0,1E30]
XLAM                         [0,infinity)                  [0,1E30]

-------------------- Student's t

      SUBROUTINE CDFT( WHICH, P, T, DF, STATUS, BOUND )

P                            [1E-7,1-E-7]                  ------------
T                            (-infinity,infinity)          [-1E30,1E30]
DF                           (0,infinity)                  [1E-30,1E30]
