      REAL FUNCTION cumbet(xx,xa,xb)
C**********************************************************************
C
C     REAL FUNCTION CUMBET(X,A,B)
C                   CUMulative incomplete BETa distribution
C
C
C                              Function
C
C
C     Returns the cdf    to   X  of the  incomplete beta    distribution
C     with  parameters a  and b.   This   is the  integral  from  0 to x
C     of (1/B(a,b))*f(t)) where f(t) = t**(a-1) * (1-t)**(b-1)
C
C
C                              Arguments
C
C
C     X --> Upper limit of integration.
C                                        X is REAL
C
C     A --> First parameter of the beta distribution.
C                                        A is REAL
C
C     B --> Second parameter of the beta distribution.
C                                        B is REAL
C
C
C                              Method
C
C
C
C     Calls the double precision version of this routine DUMBET.
C
C**********************************************************************
C     ..
C     .. Scalar Arguments ..
      REAL xa,xb,xx
C     ..
C     .. External Functions ..
      DOUBLE PRECISION dumbet
      EXTERNAL dumbet
C     ..
C     .. Executable Statements ..
      cumbet = real(dumbet(dble(xx),dble(xa),dble(xb)))
      RETURN

      END
