      Real*8 FUNCTION cumchi(x,df)
C**********************************************************************
C
C     Real*8 FUNCTION CUMCHI(X,DF)
C             CUMulative of the CHi-square distribution
C
C
C                              Function
C
C
C     Calculates the cumulative chi-square distribution.
C
C
C                              Arguments
C
C
C     X       --> Upper limit of integration of the
C                 chi-square distribution.
C						  X is Real*8
C
C     DF      --> Degrees of freedom of the
C                 chi-square distribution.
C						  DF is Real*8
C
C
C                              Method
C
C
C     Calls incomplete gamma function (CUMGAM)
C
C**********************************************************************
C     .. Scalar Arguments ..
      Real*8 df,x
C     ..
C     .. Local Scalars ..
      Real*8 a,xx
C     ..
C     .. External Functions ..
      Real*8 cumgam
      EXTERNAL cumgam
C     ..
C     .. Executable Statements ..
      a = df*0.5D0
      xx = x*0.5D0
      cumchi = cumgam(xx,a)
      RETURN

      END
