      Real*8 FUNCTION cumgam(xx,aa)
C
C**********************************************************************
C
C     Real*8 FUNCTION CUMGAM(X,A)
C                    CUMulative incomplete GAMma distribution
C
C
C                              Function
C
C
C     Computes   the  cumulative        of    the     incomplete   gamma
C     distribution, i.e., the integral from 0 to X of
C          (1/GAM(A))*EXP(-T)*T**(A-1) DT
C     where GAM(A) is the complete gamma function of A, i.e.,
C          GAM(A) = integral from 0 to infinity of
C                    EXP(-T)*T**(A-1) DT
C
C
C                              Arguments
C
C
C     X --> The upper limit of integration of the incomplete gamma.
C						 X is Real*8
C
C     A --> The shape parameter of the incomplete gamma.
C						 A is Real*8
C
C
C                              Method
C
C
C     Calls the routine GRATIO.
C
C**********************************************************************
C
C     ..
C     .. Scalar Arguments ..
      Real*8 aa,xx
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION ans,qans
C     ..
C     .. External Routines ..
      EXTERNAL gratio
C     ..
C     .. Executable Statements ..
      IF (.NOT. (xx.LE.0.0)) GO TO 10
      cumgam = 0.0
      RETURN

C     Call gratio routine

   10 CALL gratio(dble(aa),dble(xx),ans,qans,1)

      cumgam = dble(ans)

      RETURN

      END
