      REAL FUNCTION cumpoi(s,xlam)
C
C**********************************************************************
C
C     REAL FUNCTION CUMPOI(S,XLAM)
C                    CUMulative POIsson distribution
C
C
C                              Function
C
C
C     Returns the  probability  of  S   or  fewer events in  a   Poisson
C     distribution with mean XLAM.
C
C
C                              Arguments
C
C
C     S --> Upper limit of cumulation of the Poisson.
C                                                  S is REAL
C
C     XLAM --> Mean of the Poisson distribution.
C                                                  XLAM is REAL
C
C
C                              Method
C
C
C     Uses formula  26.4.21   of   Abramowitz and  Stegun,  Handbook  of
C     Mathematical   Functions  to reduce   the   cumulative Poisson  to
C     the cumulative chi-square distribution.
C
C**********************************************************************
C     .. Scalar Arguments ..
      REAL s,xlam
C     ..
C     .. Local Scalars ..
      REAL chi,df
C     ..
C     .. External Functions ..
      REAL cumchi
      EXTERNAL cumchi
C     ..
C     .. Executable Statements ..
      df = 2.0* (s+1.0)
      chi = 2.0*xlam
      cumpoi = 1.0 - cumchi(chi,df)
      RETURN

      END
