      DOUBLE PRECISION FUNCTION dumgam(xx,aa)
C
C**********************************************************************
C
C     DOUBLE PRECISION FUNCTION DUMGAM(X,A)
C         Double precision cUMulative incomplete GAMma distribution
C
C
C                              Function
C
C
C     Computes   the  cumulative        of    the     incomplete   gamma
C     distribution, i.e., the integral from 0 to X of
C          (1/GAM(A))*EXP(-T)*T**(A-1) DT
C     where GAM(A) is the complete gamma function of A, i.e.,
C          GAM(A) = integral from 0 to infinity of
C                    EXP(-T)*T**(A-1) DT
C
C
C                              Arguments
C
C
C     X --> The upper limit of integration of the incomplete gamma.
C                                                X is DOUBLE PRECISION
C
C     A --> The shape parameter of the incomplete gamma.
C                                                A is DOUBLE PRECISION
C
C
C                              Method
C
C
C     Calls the routine GRATIO.
C
C**********************************************************************
C
C     ..
C     .. Scalar Arguments ..
      DOUBLE PRECISION aa,xx
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION ans,qans
C     ..
C     .. External Routines ..
      EXTERNAL gratio
C     ..
C     .. Executable Statements ..
      IF (.NOT. (xx.LE.0.D0)) GO TO 10
      dumgam = 0.D0
      RETURN

C     Call gratio routine

   10 CALL gratio(aa,xx,ans,qans,0)

      dumgam = ans

      RETURN

      END
