      REAL FUNCTION lbico(n,s)
      IMPLICIT REAL (a-h,o-p,r-z),INTEGER (i-n),LOGICAL (q)
C**********************************************************************
C
C     REAL FUNCTION LBICO(N,S)
C             calculate Log of BInomial COefficient
C
C
C                              Function
C
C
C     Calculates the log of the binomial coefficient of S objects
C     in a set of size N.
C
C
C                              Arguments
C
C
C     N       --> Sample size.
C                                                 N is INTEGER
C
C     S       --> Number of objects in subset.
C                                                 S is INTEGER
C
C
C                              Method
C
C
C     The log of the binomial coefficient is calculated directly,
C     using routine XLFACT, which calculates the factorial of its
C     one integer argument using a table of logarithms.
C
C**********************************************************************
      INTEGER n,s
      DOUBLE PRECISION nlfact,slfact,nmslfc
      DOUBLE PRECISION xlfact
C
C *** Main body of program
C
C
C     If S is equal to zero or N, return zero.
C     If S is out of valid bounds, stop execution.
C     Otherwise, proceed with calculation.
C
      IF (.NOT. (s.EQ.0)) GO TO 10
      lbico = 0.0
      GO TO 70

   10 IF (.NOT. (s.EQ.n)) GO TO 20
      lbico = 0.0
      GO TO 70

   20 IF (.NOT. (s.LT.0)) GO TO 30
      !STOP 'S less than 0 in LBICO'
      write(*,*) 'S less than 0 in LBICO'

      GO TO 70

   30 IF (.NOT. (s.GT.n)) GO TO 40
      !STOP 'S greater than 0 in LBICO'
      write(*,*) 'S greater than 0 in LBICO'

      GO TO 70

   40 IF (.NOT. (n.LE.0)) GO TO 50
      !STOP 'N less than or equal to 0 in LBICO'
      write(*,*) 'N less than or equal to 0 in LBICO'

      GO TO 70
C     CALCULATE-LOG-BINOMIAL-COEFFICIENT
   50 ASSIGN 60 TO i99993
      GO TO 80

   60 CONTINUE
   70 RETURN
C
C
C
      !STOP '*** EXECUTION FLOWING INTO FLECS PROCEDURES ***'
      write(*,*) '*** EXECUTION FLOWING INTO FLECS PROCEDURES ***'
C     TO CALCULATE-LOG-BINOMIAL-COEFFICIENT
C**********************************************************************
C
C     Calculate log of binomial coefficient from logarithms of
C     N!, S! and (N-S)!
C
C**********************************************************************
C
C     Calculate logarithms of N!, S! and (N-S)!
*
   80 nlfact = xlfact(n)
      slfact = xlfact(s)
      nmslfc = xlfact(n-s)
C
C     Calculate log of binomial coefficient.
C
      lbico = real(nlfact- (slfact+nmslfc))
C
      GO TO i99993
C
      END
