      LOGICAL FUNCTION qstinv(f,qincr,x,y,small,big,absstp,relstp,
     +                        abstol,reltol,qleft,qhi)
C**********************************************************************
C
C     QSTINV is an exact renamed copy of QMFINV.  It is intended to be
C     used only for inverting statistical functions and not for general
C     purposes.
C
C**********************************************************************
C
C     .. Scalar Arguments ..
      Real*8 absstp,abstol,big,relstp,reltol,small,x,y
      LOGICAL qhi,qincr,qleft
C     ..
C     .. Function Arguments ..
      Real*8 f
      EXTERNAL f
C     ..
C     .. Local Scalars ..
      Real*8 step,xlb,xub,yy,zx,zy,zz
      LOGICAL qbdd,qcond,qlim,qup
C     ..
C     .. External Functions ..
      LOGICAL qstzro
      EXTERNAL qstzro
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC abs,max,min
C     ..
C     .. Statement Functions ..
      LOGICAL qxmon
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Statement Function definitions ..
      qxmon(zx,zy,zz) = zx .LE. zy .AND. zy .LE. zz
C     ..
C     .. Executable Statements ..
      qcond = .NOT. qxmon(small,x,big)
      IF (.NOT. (qcond)) GO TO 10
      !STOP ' SMALL, X, BIG NOT MONOTONE IN QSTINV'
      write(*,*) ' SMALL, X, BIG NOT MONOTONE IN QSTINV'

   10 qstinv = .TRUE.
      step = max(absstp,relstp*abs(x))
      yy = f(x) - y
      IF (yy.EQ.0.0) RETURN
      qup = (qincr .AND. (yy.LT.0.0)) .OR.
     +      (.NOT.qincr .AND. (yy.GT.0.0))
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C     HANDLE CASE IN WHICH WE MUST STEP HIGHER
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IF (.NOT. (qup)) GO TO 70
      xlb = x
      xub = min(xlb+step,big)
      GO TO 30

   20 IF (qcond) GO TO 60
   30 yy = f(xub) - y
      qbdd = (qincr .AND. (yy.GE.0.0)) .OR.
     +       (.NOT.qincr .AND. (yy.LE.0.0))
      qlim = xub .GE. big
      qcond = qbdd .OR. qlim
      IF (qcond) GO TO 40
      step = step*2.0
      xlb = xub
      xub = min(xlb+step,big)
   40 IF (.NOT. (qlim.AND..NOT.qbdd)) GO TO 50
      qstinv = .FALSE.
      qleft = .FALSE.
      qhi = .NOT. qincr
      x = big
      RETURN

   50 GO TO 20

   60 GO TO 130
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C     HANDLE CASE IN WHICH WE MUST STEP LOWER
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   70 xub = x
      xlb = max(xub-step,small)
      GO TO 90

   80 IF (qcond) GO TO 110
   90 yy = f(xlb) - y
      qbdd = (qincr .AND. (yy.LE.0.0)) .OR.
     +       (.NOT.qincr .AND. (yy.GE.0.0))
      qlim = xlb .LE. small
      qcond = qbdd .OR. qlim
      IF (qcond) GO TO 100
      step = step*2.0
      xub = xlb
      xlb = max(xub-step,small)
  100 GO TO 80

  110 IF (.NOT. (qlim.AND..NOT.qbdd)) GO TO 120
      qstinv = .FALSE.
      qleft = .TRUE.
      qhi = qincr
      x = small
      RETURN

  120 CONTINUE
  130 IF (qstzro(f,y,xlb,xub,abstol,reltol)) CONTINUE
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C     IF WE REACH HERE, XLB AND XUB BOUND THE ZERO OF F.
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      x = xlb
      RETURN

      END
