c Verify95_g77.for
c
c Changes:
c          - path separator
c          - single quotes to double quotes
c          - commented out $If Defined(TrackFunctionCalls)
c          - commented out    USE MSFLIB
c          - commented out $If Defined(AllowOverFlow)
c          - commented out time routines: c       CALL GETDAT (iyr, imon, iday)
c              CALL GETTIM (ihr, imin, isec, i100th)
c          - commented out $If Defined (SpitOutIntegrand)
c       - commented out call flush(8) ! 1-9-98, 10:10pm
c     - made sure it always uses the dqaqs integration routine (that's how I had compiled it)

c
c Gnu Fortran version of verify program...
c This file contains the programs that verify that the confidence limits
c       are returning the correct values.  This is done by evaluating
c       an integral of the standard confidence limits.
c
c BFL, 1-2-98, 9:09pm
c
c
c This file contains programs for verifying that things
c are working correctly.
c
c This was initially done in dlls, but there were problems with
c the two-tailed routine dll file (when called by Excel).
c
c B.F. Lyon, 10-2-95, 5pm


c       include '..\program\dqags.for'
       include "dqags.for"
cinclude "../testing/Mainguts_g77.F"
cinclude "../testing/Chinorm.F"

       Subroutine WriteVerifyInfo
       
      write(*,*)
       write(*,*)  
      write(*,*) "This program can be used to verify the program that"
      write(*,*) "calculates confidence limits on linear functions of"
       write(*,*) "the normal mean and variance. Only the standardized"
       write(*,*) "case of mu=0, lambda=0.5, gamma-squared=df+1 is "
       write(*,*) "considered here."
       write(*,*)
       write(*,*) "Terms/guidance:"
       write(*,*) 
           write(*,*) "Adapquadtolerance - how closely int is approx"
       write(*,*) "(this is integral of conf. limits, not how"
       write(*,*)  "   accurately limits are approximated)"
      write(*,*) "FunctionTolerance - how accurate limits are"
        write(*,*) "ResultTol(opt) - value sets how close to zero "
        write(*,*)  "  functions must be in conf. limit program"
       write(*,*)
       write(*,*) "Suggested values are in parentheses."
       write(*,*)

       End !Subroutine WriteVerifyInfo

       Subroutine Verify_Main

       ! 1-18-98 11:31pm
       ! Main subroutine that si the "interactive" version of the verification program
       !
       Real*8 ApproxIntegral, ApproxIntegral1,ApproxIntegral2
       Real*8 Diff
       Real*8 mu, sigma, lambda,alpha, df
       Real*8 AdapQuadTolerance,FunctionTolerance,ResultTol
       Integer*4 ITrackFunction,  Numcalls
       Integer MaxLevel, MaxLevel_1, MaxLevel_2
       Integer Lower, Upper
       Integer OneorTwoTail

       Lower=1
       Upper=2

c$If Defined(TrackFunctionCalls)
c       iTrackFunction=23 ! 1-13-98 9:26pm 
c       open(unit=iTrackFunction,file="trackfcn.out")
c$End If


20       Call WriteVerifyInfo

c       write(*,"(a/)") " Verify one(1) or two(2)-sided limits?"
       write(*,*) " Verify one(1) or two(2)-sided limits?"
      read(*,*) OneorTwoTail
       If (OneorTwotail.eq.2) then
      write(*,*) "Warning! Verification for two-sided limits usually"
      write(*,*) "takes only a few minutes, but can take up"
      write(*,*) "to several hours in some cases (Pentium 75)."
       end if

       write(*,*) "Enter df, sigma, alpha"
       read(*,*) df, Sigma, alpha
       write(*,*) 
     &       "Enter AdapQuadTolerance(1e-6),FunctionTolerance(1e-8),"
     &     // "ResultTol(0)"
       read(*,*) AdapQuadTolerance,FunctionTolerance,ResultTol

       Mu=0.0d0
       Lambda=0.50d0

       
c$If Defined(TrackFunctionCalls)
c      
c        write(iTrackFunction,*) "df,sigma,alpha : ",df,sigma,alpha 
c        write(iTrackFunction,*) "AdapQuadTolerance,FunctionTolerance, "
c     &     //"ResultTol"
c       write(iTrackFunction,*) 
c     &        AdapQuadTolerance,FunctionTolerance,ResultTol
c
c       call flush(iTrackFunction) ! 1-20-98 10:16pm
c$End If
       

       If (OneorTwotail.eq.1) then
        Call VerifyOneTail(Upper,Mu, Sigma, lambda, df, alpha,
     &        AdapQuadTolerance,FunctionTolerance,ResultTol,
     &         ApproxIntegral, Diff, 
     &         MaxLevel,
     &         NumCalls,iTrackFunction)

      write(*,*) "Approx. to integral is (should be 1-alpha)",
     &       ApproxIntegral
       write(*,*) "Difference of approx.and 1-alpha is ",Diff


       Else
          Call VerifyTwoTail(Mu, Sigma, lambda, df, alpha,
     &        AdapQuadTolerance,FunctionTolerance,ResultTol,
     &         ApproxIntegral1, ApproxIntegral2,Diff, 
     &         MaxLevel,
     &         NumCalls,iTrackFunction)

       write(*,*) 
      write(*,*) "Approx to integral (should be !1-alpha)",
     &        1.0d0-ApproxIntegral1+ApproxIntegral2
      write(*,*) "Difference of approx. and 1-alpha is ",Diff


       End If
c$If Defined(TrackFunctionCalls)
c       write(iTrackFunction,*) "------------------"
c       write(iTrackFunction,*)
c        call flush(iTrackFunction) ! 1-20-98 10:16pm
c$End If

              write(*,*) "Hit enter to continue"
              read(*,*)
              Goto 20

       end       !Subroutine Verify_Main


       Subroutine VerifyTwoTail(Mu, Sigma, lambda, df, alpha,
     &        AdapQuadTolerance,FunctionTolerance,ResultTol,
     &         ApproxIntegral1, ApproxIntegral2,Diff, 
     &         MaxLevel,
     &         NumCalls,iTrackFunction)
       ! The purpose of this subroutine is to approximate the integral used to evaluate the
       ! accuracy of the confidence limit program.       The program calculates confidence limits on 
       ! the term mu + lambda*sigma^2, where mu and sigma are the mean and standard deviation
       ! of a normal distribution, respectively, and lambda is a real number.
       !
       ! The program is verified by calculating an integral of a function involving the 
       ! possible values for the sample mean and standard deviation, given mu and sigma.
       ! The confidence limit program is used in the calculation of the integrand (TwoTailCriticalP).

       ! Due to the manner in which the confidence limits are calculated, it can be assumed that
       ! mu=0 and lambda=0.5.

       ! BFL, 1-18-98, 11:03pm
       ! The basic quantity calculated is the integral
       !  1
       !  / TwoTailCriticalP(q)  dq
       !  \
       !  0
       !
       ! In this case, it is broken up into integrals over each half of the unit interval
       !
       ! The integrand is not defined at the endpoints, and so some decision must be made about 
       ! how this is addressed.  Here, the chosen tolerance for the adaptive quadrature routine
       ! (AdapquadTolerance) is used to determine the endpoints.  In particular, the lower endpoint
       ! of integration is equal to the tolerance, and the upper endpoint is 1 minus the tolerance.
       ! This introduces an error of at most 2*AdapquadTolerance since the integrand is has values
       ! between 0 and 1. This must be kept in mind when considering the results.

       ! Input
       ! -----
       !  WhichLimit        - Upper (2) or lower (1) limit (lower = upper (1-alpha))
       !  AdapquadTolerance - Depending on the behavior of the integrand, the integral approximation 
       !                  may be accurate with absolute error "AdapquadTolerance".  However, the
       !                  actual bound may be larger.  The critical factor in the accuracy is the
       !                  behavior of the fourth derivative of the integrand (this is a feature of
       !                  the adaptive quadrature routine).
       !
       ! Sigma            - Actual standard deviation upon which the test is being performed 
       ! Lambda           - mu + lambda*sigma^2
       ! df                             - The degrees of freedom
       ! alpha            - Level of confidence for which the algorithm is being verified.
       ! FunctionTolerance  - This governs the accuracy of the integrand.  It is the "Tolerance" 
       !                  used by the confidence limit program.  It should always be set to a
       !                  value less than AdapquadTolerance, otherwise numerical fluctuations in 
       !                  the evaluation of the integrand can prevent the adaptive quadrature
       !                  from converging.
       ! iTrackFunction     - Unit for outputfile to which intermediate output is written.  This output
       !                  consists of the points in the interval (0,1) where the integrand was
       !                  evaluated, and the integrand itself.
         
       ! Output
       
    ! ApproxIntegral1     - Approximation to the integral for lower two-sided conf. limit
    ! ApproxIntegral2     - Approximation to the integral for upper two-sided conf. limit
    
    !  1-ApproxIntegral1 + ApproxIntegral2 should be close to 1-alpha
       ! Diff             - Difference between (ApproxIntegral1+ApproxIntegral2) and 1-alpha
    ! NumCalls         - the number of times the integrand was evaluated in the evaluation of 
       !                  the integrals
       ! MaxLevel                      - Maximum level used in the adaptive quadrature routine
       !

       External TwoTailCriticalP
       Real*8 TwoTailCriticalP
       Real*8 AdapQuadforCriticalP
       Real*8 a1,b1,a2,b2
       Real*8 ApproxIntegral1,ApproxIntegral2
       Real*8 Diff
       Real*8 mu, sigma, lambda,alpha, df
       Real*8 AdapQuadTolerance,FunctionTolerance,ResultTol
       Integer*4 ITrackFunction,  Numcalls
       Integer*4 ml1, ml2,m21,m22
       Integer*4 NumCalls1, Numcalls2,NumCalls3, Numcalls4
       Integer MaxLevel, MaxLevel_1, MaxLevel_2
       Integer Lower, Upper

       Lower=1
       Upper=2

        a1=AdapquadTolerance
        b1=0.50d0
        a2=0.50d0
        b2=1.0d0-AdapquadTolerance                                                         


      ApproxIntegral1=AdapQuadforCriticalP(TwoTailCriticalP,Lower,
     &          a1,b1,Mu, Sigma, lambda, df, alpha,
     &   AdapQuadTolerance,FunctionTolerance,ResultTol,m21,
     &  NumCalls3,iTrackFunction) +
     &         AdapQuadforCriticalP(TwoTailCriticalP,Lower,
     &          a2,b2,Mu, Sigma, lambda, df, alpha,
     &   AdapQuadTolerance,FunctionTolerance,ResultTol,m22,
     &      NumCalls4,iTrackFunction)

         If (m21.gt.m22) then
            MaxLeve2_1=m21
        else
            MaxLeve2_1=m22
        end if


        ApproxIntegral2 =
     &         AdapQuadforCriticalP(TwoTailCriticalP,Upper,
     &          a1,b1,Mu, Sigma, lambda, df, alpha,
     &       AdapQuadTolerance,FunctionTolerance,ResultTol,m11,
     &     NumCalls1,iTrackFunction)
     &            +
     &         AdapQuadforCriticalP(TwoTailCriticalP,Upper,
     &          a2,b2,Mu, Sigma, lambda, df, alpha,
     &       AdapQuadTolerance,FunctionTolerance,ResultTol,m12,
     &       NumCalls2,iTrackFunction)

        
        NumCalls=NumCalls1+Numcalls2+NumCalls3+NumCalls4        

        Diff = 1.0d0-ApproxIntegral1 + ApproxIntegral2 - (1.0d0-alpha)
       
        If (ml1.gt.ml2) then
            MaxLevel_1=ml1
        else
            MaxLevel_1=ml2
        end if

        If (MaxLevel_1.gt.MaxLevel_2) then
            MaxLevel=MaxLevel_1
        else
            MaxLevel=MaxLevel_2
        end if


       End !Subroutine VerifyTwoTail



       Subroutine VerifyOneTail(WhichLimit,Mu, Sigma, lambda, df, alpha,
     &        AdapQuadTolerance,FunctionTolerance,ResultTol,
     &         ApproxIntegral, Diff, 
     &         MaxLevel,
     &         NumCalls,iTrackFunction)
       ! The purpose of this subroutine is to approximate the integral used to evaluate the
       ! accuracy of the confidence limit program.       The program calculates confidence limits on 
       ! the term mu + lambda*sigma^2, where mu and sigma are the mean and standard deviation
       ! of a normal distribution, respectively, and lambda is a real number.
       !
       ! The program is verified by calculating an integral of a function involving the 
       ! possible values for the sample mean and standard deviation, given mu and sigma.
       ! The confidence limit program is used in the calculation of the integrand (CriticalPNew).

       ! Due to the manner in which the confidence limits are calculated, it can be assumed that
       ! mu=0 and lambda=0.5.

       ! BFL, 1-18-98, 9:13pm

       ! The basic quantity calculated is the integral
       !  1
       !  / CriticalPNew(q)  dq
       !  \
       !  0
       !
       ! In this case, it is broken up into integrals over each half of the unit interval
       !
       ! The integrand is not defined at the endpoints, and so some decision must be made about 
       ! how this is addressed.  Here, the chosen tolerance for the adaptive quadrature routine
       ! (AdapquadTolerance) is used to determine the endpoints.  In particular, the lower endpoint
       ! of integration is equal to the tolerance, and the upper endpoint is 1 minus the tolerance.
       ! This introduces an error of at most 2*AdapquadTolerance since the integrand is has values
       ! between 0 and 1. This must be kept in mind when considering the results.

       ! Input
       ! -----
       !  WhichLimit        - Upper (2) or lower (1) limit (lower = upper (1-alpha))
       !  AdapquadTolerance - Depending on the behavior of the integrand, the integral approximation 
       !                  may be accurate with absolute error "AdapquadTolerance".  However, the
       !                  actual bound may be larger.  The critical factor in the accuracy is the
       !                  behavior of the fourth derivative of the integrand (this is a feature of
       !                  the adaptive quadrature routine).
       !
       ! Sigma            - Actual standard deviation upon which the test is being performed 
       ! Lambda           - mu + lambda*sigma^2
       ! df                             - The degrees of freedom
       ! alpha            - Level of confidence for which the algorithm is being verified.
       ! FunctionTolerance  - This governs the accuracy of the integrand.  It is the "Tolerance" 
       !                  used by the confidence limit program.  It should always be set to a
       !                  value less than AdapquadTolerance, otherwise numerical fluctuations in 
       !                  the evaluation of the integrand can prevent the adaptive quadrature
       !                  from converging.
       ! iTrackFunction     - Unit for outputfile to which intermediate output is written.  This output
       !                  consists of the points in the interval (0,1) where the integrand was
       !                  evaluated, and the integrand itself.
         
       ! Output
       
    ! ApproxIntegral     - Approximation to the integral (this should be close to 1-alpha)
       ! Diff             - Difference between ApproxIntegral and 1-alpha
    ! NumCalls         - the number of times the integrand was evaluated in the evaluation of 
       !                  the integral
       ! MaxLevel                      - Maximum level used in the adaptive quadrature routine
       !

       External CriticalPNew
       Real*8 CriticalPNew
       Real*8 AdapQuadforCriticalP
       Real*8 a1,b1,a2,b2
       Real*8 ApproxIntegral
       Real*8 Diff
       Real*8 mu, sigma, lambda,alpha, df
       Real*8 AdapQuadTolerance,FunctionTolerance,ResultTol
       Integer*4 ITrackFunction,  Numcalls
       Integer*4 ml1, ml2
       Integer*4 NumCalls1, Numcalls2
       Integer WhichLimit,MaxLevel

        a1=AdapquadTolerance
        b1=0.50d0
        a2=0.50d0
        b2=1.0d0-AdapquadTolerance                                                         


        ApproxIntegral =
     &         AdapQuadforCriticalP(CriticalPNew,WhichLimit,
     &          a1,b1,Mu, Sigma, lambda, df, alpha,
     &        AdapQuadTolerance,FunctionTolerance,ResultTol,m11,
     &         NumCalls1,iTrackFunction)
     &            +
     &         AdapQuadforCriticalP(CriticalPNew,WhichLimit,
     &          a2,b2,Mu, Sigma, lambda, df, alpha,
     &        AdapQuadTolerance,FunctionTolerance,ResultTol,m12,
     &       NumCalls2,iTrackFunction)
        Diff = ApproxIntegral - (1.0d0-alpha)
        NumCalls = NumCalls1 + NumCalls2
        If (ml1.gt.ml2) then
            MaxLevel=ml1
        else
            MaxLevel=ml2
        end if
       End !Subroutine VerifyOneTail


      Subroutine WriteInfo_readFile

       WRITE (6,"(A1)") "-"
       WRITE (6,*) "This program is used to assist in verifying" 
       write(6,*)  "the accuracy of the calculated confidence limits"
       WRITE (6,*) "for a given degrees of freedom, s and alpha. "
       write (6,*) "There is minimal error-checking on user-input."
       write(6,*) "The possible values for sigma, df, alpha are set."
       write(6,*) "Based on the contents of the input file, some "
       write(6,*) "or all of these cases will be tested."
          
          !write(6,*) "See the accompanying README file for more details."
          
      End ! Subroutine WriteInfo


       !include "mainguts.for"
       !include "c:\cdfs\inverses\chinorm.for" !chi-squared and norm inverse


        Program TestIt

c       USE MSFLIB

        External CriticalPNew,TwoTailCriticalP
        Real*8 AdapQuadforCriticalP
        Real*8  a1,a2,b1,b2,Mu, Sigma, lambda, df, alpha,
     &              AdapQuadTolerance
        Real*8 FunctionTolerance
        Real*8 ans1,ans2,CriticalPNew
        !Real*8 TwoTailforVerify
        Integer i,Lower,Upper,WhichLimit
        Real*8 TwoTailCriticalP
        !Real*8 ulimit,llimit
        Real*8 a(10),ss(14),nu(18)
        Integer m11,m12,m21,m22
        Integer One, Two, OneorTwo
        Real*8 q,TrueMu,TrueSigma
        !real*8 Tolerance,ResultTol These are in the common file control.cmn below
        Real*8 Theq
        !Integer*2 ihr,imin,isec,i100th
        Real*8 Time1,Time2
        Real*8 FasterTwoTailCriticalP,Tol
        Character*72 TheOutFileName
        Character*72 DateString
       Character*72 sInputFileName       ! 1-2-98 9:36pm
       Real*8 samplesigma,Topq,ChiInverse !1-4-98,10:19pm
       real*8 x_kk_up,x_kk_lo,Bottomq ! 1-6-98, 9:17pm
       Integer*4 NumCalls,NumCalls1,NumCalls2,NumCalls3,NumCalls4 ! Number of function calls in adaptive quad routine 1-9-98 11:07pm
        Integer*4 iTrackFunction ! 1-13-98 9:25pm file for output of integrand.
       Real*8 ApproxIntegral, Diff ! 1-18-98 10:46pm
       Real*8 ApproxIntegral1, ApproxIntegral2 ! 1-18-98 11:17pm
       Integer*4 Interactive ! 1-19-98 12:16am
       Integer*2 iyr, imon, iday,ihr, imin, isec, i100th  ! 1-19-98 12:22am
      !alpha=0.95
        !AdapQuadTolerance=1d-5
        !FunctionTolerance=1d-7 ! accuracy of function
        !ResultTol=1d-9  !100 !1e-7

        !jj=1
       include "control.cmn"
       Integer(2) control, control_old ! 1-10-98 4:37pm
      real*8 x
       Integer*4 k_sigma_start, k_sigma_stop ! 2-3-98 9:39pm
       Integer*4 iostat ! 2-3-98 9:45pm

        ArgTop=800.0
        NumIt=200 ! back to 200, I want to get a verified version 9:20pm changed 200 to 50 bfl 1-13-98 9:14pm

       
       Write (*,*) "Interactive version (1) or read input file(2)?"
       read(*,*) Interactive
       If (Interactive.eq.1) then
          call Verify_Main  ! 1-18-98 11:48pm
       End If

       


c commented out 1-18-98, 10:43pm
c       do i=1,100
c       write(*,*) "enter sigma,df,q"
c       read(*,*) sigma,df,theq
c       !write(*,*) dexp(X)
c       ! max is ~ 709.0
c             samplesigma=sigma * dsqrt(ChiInverse(theq, df,1.0d-15) / df)  !1-4-98,10:18pm
c       write(*,*) samplesigma
c       write(*,*)
c       end do

c$If Defined(AllowOverFlow)
c       CALL GETCONTROLFPQQ(control)
c      control_old = control
c       control  = control .AND. FPCW$OVERFLOW
c       control  = control .AND. #0020  !FPCW$INEXACT
c
c      !     Set new control to allow overflow       
c       !CALL SETCONTROLFPQQ(control)
c
c$End If
       
c$If Defined(TrackFunctionCalls)
c       iTrackFunction=23 ! 1-13-98 9:26pm 
c       open(unit=iTrackFunction,file="trackfcn.out")
c$End If
        !WhichLimit=Upper
        TrueSigma=10.0d0
        lambda=0.50d0
        TrueMu=0.0d0
        df=1000.0d0
        alpha=0.9990d0

        jj=-1
        Do While (jj.gt.0)

           write(*,*) "Enter WhichLimit,q,Tol "
           read(*,*) WhichLimit,q,Tol
           write(*,*) "p is ",
     &          FasterTwoTailCriticalP(
     &          WhichLimit, q,TrueMu, TrueSigma,lambda,
     &           df, alpha,Tolerance,ResultTol)

        End Do


        mu=0.0d0

        Lambda=0.50d0
        Lower=1
        Upper=2

        a(1)=0.001D0
        a(2)=0.005D0
        a(3)=0.01D0
        a(4)=0.05D0
        a(5)=0.1d0
        a(6)=0.9d0
        a(7)=0.95D0
        a(8)=0.99D0
        a(9)=0.995D0
        a(10)=0.999D0

        ss(1)=0.1d0
        ss(2)= 1.0d0
        ss(3)=10.0d0
        !ss(4)=10
        !ss(5)=10


        nu(1)=2.0d0
        nu(2)=3.0d0
        nu(3)=5.0d0  !10
        nu(4)=10.0d0
        nu(5)=100.0d0
        nu(6)=1000.0d0

        One=1
        Two=2
        OneorTwo=Two

       Call WriteInfo_ReadFile

       ! Open the input file to find out what"s what
        write(6,*) " Enter name of input file "
       read(5,*) sInputFileName

       !write(6,*) sInputFileName
      Open(unit=12,file=sInputFileName)
       !write(6,*) "Opened file ok..."
       !read(5,*)
       !stop

      !Open(unit=12,file="input.dat")
       
c5       write(6,*) "Enter 1 for one-sided or 2 for two-sided"
       read(12,*) OneorTwo
       If ((OneorTwo.ne.One).and.(OneorTwo.ne.Two)) then
       write(6,*) " Error in 1st line of file "//sInputFileName  
       write(6,*) " Value must be 1 or 2 for testing one- or "
     &              // "two-sided limits."
           write(6,*) "Value in file is ",OneorTwo
              stop
       end if
     
            If (OneorTwo.eq.One) then
       ! read stuff for one-sided limits
       read(12,*) k_alphastart, k_alphastop !1-10
              read(12,*) j_nustart, j_nustop  !1-6
       read(12,*) AdapQuadTolerance,FunctionTolerance,
     &              ResultTol
       read(12,*) TheOutFileName
       !read(12,*) DateString
       
       Else
       If (OneorTwo.eq.Two) then
              read(12,*) k_alphastart, k_alphastop !6-10
              read(12,*) j_nustart, j_nustop  !1-6
              ! read stuff for two-sided limits
       read(12,*) AdapQuadTolerance,FunctionTolerance,
     &           ResultTol

              read(12,*) TheOutFileName
              !read(12,*) DateString
              End If
       End If

       read(12,*, IOSTAT=iostat) k_sigma_start, k_sigma_stop  ! 2-3-98 9:39pm
       If (iostat.ne.0) then
       write(*,*) "Error reading sigmas.  Will do all three..."
       k_sigma_start=1
       k_sigma_stop=3
       end if ! 2-3-98 10:03pm
       Close(12)
        a1=AdapquadTolerance
         b1=0.50d0
        a2=0.50d0
        b2=1.0d0-AdapquadTolerance                                                         


        ! Let"s test things

c         Do i= 1,20
c           TrueMu=0
c           TrueSigma=0.1
c           lambda=0.5
c           df=3
c           alpha=0.995
c           Tolerance=1e-4
c
c           q = i/20.0
c           p1=
c     &   TwoTailCriticalP(
c     &    1,q,TrueMu, TrueSigma, lambda,
c     &    df, alpha, Tolerance)
c
c          p1=
c     &   TwoTailCriticalP(
c     &    2,q,TrueMu, TrueSigma, lambda,
c     &    df, alpha, Tolerance)
c         End Do




        If (OneorTwo.eq.Two) then

        open(unit=8,file="newveri.int")
        write(8,*) "Intermediate results for verifying two-tailed..."

        open(unit=7,file=TheOutFileName)
        write(7,*) "Verifying two-tailed "
        !write(7,*) "UpperInt   LowerInt  1-LowerInt  Upp+1-Lowr"
        !write(*,*) "UpperInt   LowerInt  1-LowerInt  Upp+1-Lowr"
c       write(7,*) DateString 
c        write(7,"(A14,1p,E10.2,A14,E10.2,A14,E10.2)")
c     &        " AdapQuadTol: ", AdapQuadTolerance,
c     &        " FunctionTol: ",FunctionTolerance,
c       &       " ResultTol: ",       ResultTol

c       CALL GETDAT (iyr, imon, iday)
c       CALL GETTIM (ihr, imin, isec, i100th)
c       write(7,"(I2,a1,I2,A4,I2,A1,I2,A1,I4)")
c     &        ihr,":",imin, "  ", imon,"/",iday,"/",iyr
c               write(7,"(A14,1p,E8.1,A14,E8.1,A14,E8.1)")
c     &        " AdapQuadTol: ", AdapQuadTolerance,
c     &        " FunctionTol: ",FunctionTolerance,
c     &        " ResultTol: ",       ResultTol


c        write(7,*)
c     &             "  alpha  df  sigma   Int  Error"

          write(7,*)
     & " alpha  df  sigma  Integ   Error  AdqTol FncTol ResTol"
       
        Do k=k_alphastart,k_alphastop !6,10 !10,10 !6,10  !6,10       !6,6  !7,7

          alpha=a(k)

c        write(*,"(A30,F8.1,F7.4,1p,2E12.4)")
c     &          " mu,a,Adapquadtol,Functol are ",
c     &              mu,alpha,AdapQuadTolerance,FunctionTolerance
c        write(7,"(A30,F8.1,F7.4,1p,2E12.4)")
c     &          " mu,a,Adapquadtol,Functol are ",
c     &              mu,alpha,AdapQuadTolerance,FunctionTolerance
c
c        write(*,"(A30,F8.1,F7.4,1p,3E9.1)")
c     &          " mu,a,Adapquadtol,Functol,ResultTol are ",
c     &              mu,alpha,AdapQuadTolerance,FunctionTolerance,ResultTol
c        write(7,"(A30,F8.1,F7.4,1p,3E9.1)")
c     &          " mu,a,Adapquadtol,Functol,ResultTol are ",
c     &              mu,alpha,AdapQuadTolerance,FunctionTolerance,ResultTol


c        write(8,"(A30,F8.1,F7.4,1p,2E12.4)")
c     &          " mu,a,Adapquadtol,Functol are ",
c     &              mu,alpha,AdapQuadTolerance,FunctionTolerance


        Do j=j_nustart,j_nustop  !2,6 !1,6

          df=nu(j)
c Here is too long line, I think, for g77
        Do i=k_sigma_start,k_sigma_stop ! made this an option, 2-3-98 10:06pm
               ! back to 1 now that it works again 1-13-98 10:43pm problem was 
               ! that failed was not being set to false before calling 
               !inversion in twotailedgbesselalways, ; 3 only again, 
               !df=3. s=10, a=0.995 is hanging now All again 12:13am ->1, 
               !12:07am 1-13-97 1-12-98 6:03mp back to 3 to see why 
               !df=3,s=10, a=0.999 is hanging...2:34 pm bac to 
               !11-10-98 12:46pm Back to 1, 1-10-98, 10:40am Baco to 3 
               !to see why df=3,alpha=.99, s=10 is hanging  1-9-98, 9:31am 
               !Back to 1 to see if all is well now that df=1000 
               !works 1-6-98, 9:54am, changed back to 3 to focus on s=10 
               !case for df=1000 (again!)!1-5-98, 10:50pm, changed lower 
               !from i=3 to i=1bfl, 1-4-98 9:29pm
            sigma=ss(i)
cAbove here
c$If Defined (SpitOutIntegrand)
c This shows you what the integrand looks like... bfl, 1-4-98, 10:02pm
c           open(unit=4,file="output.dat")
c           write(4,*) "df,sig,alpha are ",df,sigma,alpha
c           Bottomq=  9.999664826049804D-001 !AdapQuadTolerance !1.0d0-AdapQuadTolerance !9.999664826049804D-1! hanging 3df, s=10, a=0.995  !AdapQuadTolerance ! 1-13-97 12:10am1.0d0-AdapQuadTolerance ! 11:14pm 1-12-98 9:08pm 9.999970000000000D-1 !0.50d0 !0.89062265625d0 !9.980438867D-1 !6.059687281d-4 !2.402341d-4
c           Topq=   AdapQuadTolerance ! 0.999997D-0 !6.059687282d-4 !2.402342d-4 ! alg. was oscillating in this range before I changed convergence criteria
c
c
c              !write(*,*) "Enter topq"
c           !read(*,*) Bottomq,Topq
c           Do kk=1,11
c              theq=Bottomq+(Topq-Bottomq)*(kk-1.0d0)/10.0d0
c
c             samplesigma=sigma * dsqrt(ChiInverse(theq, df,1.0d-15) / df)  !1-4-98,10:18pm
c         write(*,*) "samplesigma is ",samplesigma
c uncommented out 1-13-98 6:17pm
c       x_kk_lo= TwoTailCriticalP(Lower,
c     &        theq, Mu, Sigma,
c     &        lambda, df, alpha, FunctionTolerance,ResultTol)
c          write(*,*) "got upper one..."
c         x_kk_up=TwoTailCriticalP(Upper,theq, Mu, Sigma,
c     &        lambda, df, alpha, FunctionTolerance,ResultTol)         ! 1-6-98
c
c              write(*,*)" Done ", theq        ,x_kk_up ,x_kk_lo  ! 1-10-98
c
c              write(4,*) theq,samplesigma,x_kk_up,x_kk_lo        ! 1-6-98
c                 call flush(4) ! flush buffer to file                                                                      
c           !read(*,*) ! "done with first q " ! 1-12-98 8:52pm
c              End Do
c              Close(4)
c        write(*,*) "Done with file..."
c$End If

        write(8,"(A20,2F10.4,F7.1,F8.3)")
     &            "Mu,Sigma,df,alpha are ",mu,sigma,df,alpha
        write(*,"(A20,2F10.4,F7.1,F8.3)")
     &            "Mu,Sigma,df,alpha are ",mu,sigma,df,alpha

c        call flush(8) ! 1-9-98, 10:10pm

c        Call GetTim(ihr,imin,isec,i100th)
        Time1=ihr*60*60+imin*60+isec +0.01*i100th



        ans2=
     &         AdapQuadforCriticalP(TwoTailCriticalP,Lower,
     &          a1,b1,Mu, Sigma, lambda, df, alpha,
     &   AdapQuadTolerance,FunctionTolerance,ResultTol,m21,
     &  NumCalls3,iTrackFunction)
     &            +
     &         AdapQuadforCriticalP(TwoTailCriticalP,Lower,
     &          a2,b2,Mu, Sigma, lambda, df, alpha,
     &   AdapQuadTolerance,FunctionTolerance,ResultTol,m22,
     &      NumCalls4,iTrackFunction)

c$If Defined(TrackFunctionCalls)
c       call flush(iTrackFunction)
c       write(iTrackFunction,*) "Done with lower two-sided."
c$End If

      ans1=AdapQuadforCriticalP(TwoTailCriticalP,Upper,
     &          a1,b1,Mu, Sigma, lambda, df, alpha,
     &       AdapQuadTolerance,FunctionTolerance,ResultTol,m11,
     &     NumCalls1,iTrackFunction) +
     &         AdapQuadforCriticalP(TwoTailCriticalP,Upper,
     &          a2,b2,Mu, Sigma, lambda, df, alpha,
     &       AdapQuadTolerance,FunctionTolerance,ResultTol,m12,
     &       NumCalls2,iTrackFunction)

c$If Defined(TrackFunctionCalls)
c       call flush(iTrackFunction)
c       write(iTrackFunction,*) "Done with upper two-sided."
c$End If

        !write(*,*) "got upper..."
        !read(*,*)


        !Call GetTim(ihr,imin,isec,i100th)
        Time2=ihr*60*60+imin*60+isec +0.01*i100th

        NumCalls=NumCalls1+Numcalls2+NumCalls3+NumCalls4
c Below here
c        call VerifyTwoTail(Mu, Sigma, lambda, df, alpha,
c     &        AdapQuadTolerance,FunctionTolerance,ResultTol,
c     &         ApproxIntegral1, ApproxIntegral2,Diff, 
c     &         MaxLevel,
c     &         NumCalls,iTrackFunction)
c
c              write(*,*) ans2,ApproxIntegral1,ApproxIntegral1-ans2 
c
c              write(*,*) ans1,ApproxIntegral2,ApproxIntegral2-ans1 
c              read(*,*)

        write(7,"(F6.3,F5.0,F7.1,1p,2(E8.1),3E7.0,0p,F9.1,A5,I7)" )
     &      alpha,df,sigma,1.0d0-(ans1+1.0d0-ans2),
     &        ans1+1.0d0-ans2-(1.0d0-alpha)
     &           ,AdapQuadTolerance,FunctionTolerance,ResultTol,
     &       (Time2-Time1)/60.0," min.",NumCalls 

c       call flush(7)  ! 1-9-98, 10:10pm

        write(*,"(F9.3,F7.0,F7.2,1p,2(E14.3),0p,F9.2,A9,I7)" )
     &          alpha,df,sigma,1-(ans1+1-ans2),ans1+1-ans2-(1-alpha)
     &          ,(Time2-Time1)/60.0," min. ",NumCalls 
cAbove here
c         write(*,*)
c     &    "  df    sigma    Uint     1-Lint    UInt+1-Lint  RelError"
c         write(*,"(F9.3,F7.0,F7.2,1p,2(E10.3),0p,4I4)" )
c     &     alpha,df,sigma,ans1+1-ans2,ans1+1-ans2-(1-alpha)
c     &     ,m11,m12,m21,m22
c         write(*,"(F7.0,F7.1,1p,3(E14.6))" )
c     &        df,sigma,ans1,1-ans2,ans1+1-ans2
        !write(*,"(1p,4(E14.6))" ) df,sigma,ans1,1-ans2,ans1+1-ans2

        !write(*,*) "Hit enter to continue..."
        !read(*,*)

        End Do ! j
        End Do ! i

        End Do ! k


       End If ! If OneorTwo=2 ! One-tailed limits

       If (OneorTwo.eq.One) then

        open(unit=7,file=TheOutFileName)
        write(7,*) "Verifying one-tailed "
c       CALL GETDAT (iyr, imon, iday)
c       CALL GETTIM (ihr, imin, isec, i100th)

       write(7,"(I2,a1,I2,A4,I2,A1,I2,A1,I4)")
     &        ihr,":",imin, "  ", imon,"/",iday,"/",iyr
               write(7,"(A14,1p,E8.1,A14,E8.1,A14,E8.1)")
     &        " AdapQuadTol: ", AdapQuadTolerance,
     &        " FunctionTol: ",FunctionTolerance,
     &        " ResultTol: ",       ResultTol

          write(7,*)
     & " alpha  df  sigma   Integral      Error  AdqTol FncTol ResTol"
c       call flush(7) ! 1-9-98, 10:10pm


c         a(1)=0.001D0
c         a(2)=0.005D0
c         a(3)=0.01D0
c         a(4)=0.05D0
c         a(5)=0.95D0
c         a(6)=0.99D0
c         a(7)=0.995D0
c         a(8)=0.999D0
c         ss(1)=0.1
c         ss(2)= 1
c         ss(3)=10
c         nu(1)=2
c         nu(2)=3
c         nu(3)=5  !10
c         nu(4)=10
c         nu(5)=100
c         nu(6)=1000

        Do k=k_alphastart, k_alphastop !3,3  !1,10

          alpha=a(k)

c        write(*,"(A30,F8.1,F7.4,1p,3E9.1)")
c     &          " mu,a,Adapquadtol,Functol,ResultTol are ",
c     &              mu,alpha,AdapQuadTolerance,FunctionTolerance,ResultTol
c        write(7,"(A30,F8.1,F7.4,1p,3E9.1)")
c     &          " mu,a,Adapquadtol,Functol,ResultTol are ",
c     &              mu,alpha,AdapQuadTolerance,FunctionTolerance,ResultTol
c Above here

        Do j=j_nustart, j_nustop  !6,6 !1,6

          df=nu(j)

        Do i=k_sigma_start,k_sigma_stop ! 2-3-98 10:07pm  
             !11:39pm I can"t see why we"re getting just over error we shouldl get...  1-14-98 9:30pm checking out df=2, a=0.001, sigma=1.0 case 1,3 !1,3

         sigma=ss(i)

c         write(7,"(A20,2F10.4,F7.1,F8.3)")
c     &       "Mu,Sigma,df,alpha are ",mu,sigma,df,alpha
c         write(*,"(A20,2F10.4,F7.1,F8.3)")
c     &       "Mu,Sigma,df,alpha are ",mu,sigma,df,alpha



c        Call GetTim(ihr,imin,isec,i100th)
        Time1=ihr*60*60+imin*60+isec +0.01*i100th

        ans1=
     &         AdapQuadforCriticalP(CriticalPNew,Upper,
     &          a1,b1,Mu, Sigma, lambda, df, alpha,
     &        AdapQuadTolerance,FunctionTolerance,ResultTol,m11,
     &         NumCalls1,iTrackFunction)
     &            +
     &         AdapQuadforCriticalP(CriticalPNew,Upper,
     &          a2,b2,Mu, Sigma, lambda, df, alpha,
     &        AdapQuadTolerance,FunctionTolerance,ResultTol,m12,
     &       NumCalls2,iTrackFunction)
c Above here
c       Call  VerifyOneTail(Upper,Mu, Sigma, lambda, df, alpha,
c     &        AdapQuadTolerance,FunctionTolerance,ResultTol,
c     &         ApproxIntegral, Diff, 
c     &         MaxLevel,
c     &         NumCalls,iTrackFunction)
c
c       write(*,*) ans1,ApproxIntegral,ApproxIntegral-ans1  ! 1-18-98 10:45pm
c       read(*,*)
c$If Defined(TrackFunctionCalls)
c       call flush(iTrackFunction)
c       write(iTrackFunction,*) "Done with one-sided."
c$End If
c        Call GetTim(ihr,imin,isec,i100th)
        Time2=ihr*60*60+imin*60+isec +0.01*i100th
c Above here       
        NumCalls=NumCalls1+NumCalls2
        write(7,"(F7.3,F5.0,F5.1,1p,2(E12.3),3E7.0,0p,F6.1,A5,I7,)" )
     &          alpha,df,sigma,1.0d0-ans1,ans1-(1.0d0-alpha),
     &          AdapQuadTolerance,FunctionTolerance,ResultTol,
     &       (Time2-Time1)/60.0," min.",NumCalls
        write(*,"(F7.3,F5.0,F9.5,1p,2(E14.3),0p,F9.2,A9,I7)" )
     &          alpha,df,sigma,1-ans1,ans1-(1-alpha)
     &          ,(Time2-Time1)/60.0," minutes",NumCalls

c       call flush(7) ! 1-9-98, 10:10pm




        End Do ! j
        End Do ! i

        End Do ! k

       End If

       Close(7) ! 1-9-98, 10:10pm

c         write(*,*) "Answer is ",
c     &   !  UpperConfLimit(
c     &   !   mu,sigma, lambda,df,alpha, Tolerance )  works
c     &   ! CriticalPNew(q,Mu, Sigma, lambda,
c     &   ! df, alpha, Tolerance)
c     &    AdapQuadforCriticalP(TwoTailCriticalP,Upper,
c     &     aa,bb,Mu, Sigma, lambda, df, alpha,
c     &     Tolerance)

        End ! MAIN
c Above here
          Real*8 Function AdapQuadforCriticalP(TheFuncz,WhichLimit,
     &          aa,bb,TrueMu, TrueSigma, lambda, df, alpha,
     &          Tolerance,FunczTolerance,ResultTol,MaxLevelUsed,
     &     NumCalls,iTrackFunction)

          Integer*4 iTrackFunction ! 1-13-98 9:32pm
       External TheFuncz ! the function being integrated
       Real*8 TheFuncz
       Integer MaxLevelUsed
       Integer WhichLimit
       Real*8  aa,bb,TrueMu, TrueSigma, lambda, df, alpha,
     &          Tolerance,FunczTolerance,ResultTol

c        Integer*4, Parameter:: MaxLevel =200  !bfl 1-4-98,9:14pm
c       Integer*4, Parameter::lenw = 4*MaxLevel
       Integer*4  MaxLevel !=200  !bfl 1-4-98,9:14pm
       Integer*4  lenw != 4*MaxLevel
       Real*8 Tol(200)
       Real*8 a(200)
       !Real*8 b(100)
       Real*8 h(200)
       Real*8 FA(200)
       Real*8 FB(200)
       Real*8 FC(200)
       Real*8 L(200)
       Real*8 s(200)

       Real*8 APP
       Real*8 TheTol
       Integer N,i
       Real*8 v1,v2,v3,v4,v5,v6,v7,v8,FD,FE,S1,S2
       Real*8 sigg,ChiInverse
       Real*8 sigg1,sigg2,sigg3
       Integer*4 NumCalls! 1-9-98, 11:05pm



c$If Defined (Use_dqags_Integrate)
      Real*8 work(800)  ! 3-17-1999 lenw) ! 1-27-98       9:11pm
       Integer       iwork(200) ! 3-17-1999 MaxLevel) ! 1-27-98       9:12pm
       Real*8 Result ! 1-27-98 9:16pm
       Real*8 abserr ! 1-27-98 9:16pm

cdqags(f,a,b,epsabs,epsrel,result,abserr,neval,ier,
c     *   limit,lenw,last,iwork,work,
c     &      WhichLimit,
c     &         TrueMu, TrueSigma, lambda,
c     &         df, alpha,Tolerance,ResultTol)
c
csubroutine dqags(f,a,b,epsabs,epsrel,result,abserr,neval,ier,
c     *   limit,lenw,last,iwork,work,
c     &      WhichLimit,
c     &         TrueMu, TrueSigma, lambda,
c     &         df, alpha,Tolerance,ResultTol)
cc 1-2

       MaxLevel =200  !bfl 1-4-98,9:14pm
       lenw = 4*MaxLevel

cAbove here
        Limit=MaxLevel
        call dqags(TheFuncz,aa,bb,Tolerance,0.0d0,result,abserr,neval,
     &         ier,
     &     limit,lenw,last,iwork,work,
     &      WhichLimit,
     &         TrueMu, TrueSigma, lambda,
     &         df, alpha,FunczTolerance,ResultTol)

c Above here=
          AdapQuadforCriticalP=Result ! 1-27-98 9:20pm
          NumCalls=neval ! 1-27-98, 9:34pm
       if (ier.gt.0) then
          write(*,*) "error is ",ier
c$If Defined (TrackFunctionCalls)
c          write(iTrackFunction,"(A16,F5.0,F5.1,F6.3,A9,I4)") 
c    &          "df,sigma,alpha ",
c     &          df, TrueSigma, alpha," ier is ",ier
c          write(iTrackFunction,"(A25,I4,2F7.2,1p,E12.6)") 
c     &          "WhichLimit,aa,bb,result ",WhichLimit,aa,bb,result
c          call flush(iTrackFunction) ! 2-2-98 8:02pm
c$End If
       !read(*,*)
       end if ! 1-27-98 9:35pm
       !write(*,*) "result is ",result,abserr,neval


          return



c Uncommented out 1-27-98, 8:50pm after I got the extra routines needed for it to compile.
c
cHere I need to get that d1mach function... it"s on machine at work for lsode stuff 1-21-98 12:08am
c$End If



c!Function CriticalPNew(q , _
c!TrueMu , TrueSigma , df , alpha )


       MaxLevel =200  !bfl 1-4-98,9:14pm
       lenw = 4*MaxLevel

          NumCalls=0 ! 1-9-98, 11:05pm
       TheTol = Tolerance  !0.0001 ! Tolerance
       N = MaxLevel  ! Maximum number of levels
       MaxLevelUsed=0

       !write(*,*) "In adap quad..."
       APP = 0.0D0
       i = 1
       Tol(i) = 10.0d0 * TheTol !0->0.0d0 1-6-98 11:53pm
       a(i) = aa
       h(i) = (bb - aa) / 2.0D0

       !write(*,*) "aa,bb,h(i) ",aa,bb,h(i)
c$If Defined(OneTailCheckArrayProblem)
c       !write(*,*) df,FunczTolerance ! 1-14-98 4:07pm
c       !read(*,*)
c       ! problem is probaly that there isn"t a common block in the noetail UpperConfLimit routien below 1-14-98 4:12pm
c$End If

c$If Defined (TrackFunctionCalls)
c    ! 1-10-98 11:23am It"s getting stuck with df=3,alpha=0.999, s=10 fo lower
c       write(*,*)  WhichLimit,"Calling with x= ",aa
c$End If

       FA(i) = TheFuncz(WhichLimit,aa, TrueMu, TrueSigma,
     &           lambda, df, alpha, FunczTolerance,ResultTol)
c$If Defined (TrackFunctionCalls)
c       NumCalls=NumCalls+1 ! 1-9-98, 11:15pm
c         write(*,"(I5,F7.0, F5.1, F8.5, I7)") 
c     &            WhichLimit,df, TrueSigma, alpha, NumCalls
c         write(*,"(A10,1p,2E22.10)") "       ",aa, FA(i) ! 1-10-98 10:41am
c      write(iTrackFunction,"(I2,F7.0,F5.1,F7.4,1p,2E22.10)")
c     &          WhichLimit,df, TrueSigma, 
c     &        alpha,aa, FA(i)
c         !call flush(iTrackFunction) ! 1-13-98 9:29pm
c$End If

c$If Defined (TrackFunctionCalls)
    ! 1-10-98 11:23am It"s getting stuck with df=3,alpha=0.999, s=10 fo lower
       ! 1-13-98 changed a(i)->aa..
c       write(*,*)  WhichLimit,"Calling with x= ",aa + h(i) 
c$End If
       FC(i) = TheFuncz(WhichLimit,aa + h(i), TrueMu,
     &           TrueSigma, lambda, df, alpha, FunczTolerance,ResultTol)
c$If Defined (TrackFunctionCalls)
c       NumCalls=NumCalls+1 ! 1-9-98, 11:15pm
c         write(*,"(I5,F7.0, F5.1, F8.5, I7)") 
c     &            WhichLimit,df, TrueSigma, alpha, NumCalls
c           write(*,"(A10,1p,2E22.10)") "       ",aa+h(i), FC(i) ! 1-10-98 10:41am
c         write(iTrackFunction,"(I2,F7.0,F5.1,F7.4,1p,2E22.10)") 
c     &            WhichLimit,df, TrueSigma, alpha,aa+h(i), FC(i)
c         !call flush(iTrackFunction) ! 1-13-98 9:29pm
c$End If

c$If Defined (TrackFunctionCalls)
c    ! 1-10-98 11:23am It"s getting stuck with df=3,alpha=0.999, s=10 fo lower
c       write(*,*)  WhichLimit,"Calling with x= ",bb
c$End If
       FB(i) = TheFuncz(WhichLimit,bb, TrueMu, TrueSigma,
     &           lambda, df, alpha, FunczTolerance,ResultTol)
c$If Defined (TrackFunctionCalls)
c       NumCalls=NumCalls+1 ! 1-9-98, 11:15pm
c         write(*,"(I5,F7.0, F5.1, F8.5, I7)") 
c     &            WhichLimit,df, TrueSigma, alpha, NumCalls
c       write(*,"(A10,1p,2E22.10)") "       ",bb, FB(i) ! 1-10-98 10:41am
c         write(iTrackFunction,"(I2,F7.0,F5.1,F7.4,1p,2E22.10)") 
c     &            WhichLimit,df, TrueSigma, alpha,bb, FB(i)
c         !call flush(iTrackFunction) ! 1-13-98 9:29pm
c$End If
       s(i) = h(i) * (FA(i) + 4.0D0 * FC(i) + FB(i)) / 3.0D0
       L(i) = 1

       Do While (i .gt. 0)

c$If Defined (TrackFunctionCalls)
c    ! 1-10-98 11:23am It"s getting stuck with df=3,alpha=0.999, s=10 fo lower
c       write(*,*)  
c     &        WhichLimit,"a_i+h_i/2, Calling with x= ",a(i) + h(i) / 2.0D0
c$End If

       FD = TheFuncz(WhichLimit,a(i) + h(i) / 2.0D0, TrueMu,
     &           TrueSigma, lambda, df, alpha, FunczTolerance,ResultTol)
c$If Defined (TrackFunctionCalls)
c       NumCalls=NumCalls+1 ! 1-9-98, 11:15pm
c        write(*,"(I5,F7.0, F5.1, F8.5, I7)") 
c     &            WhichLimit,df, TrueSigma, alpha, NumCalls
c         write(*,"(A10,1p,2E22.10)") "       ",a(i)+h(i)/2.0d0, FD ! 1-10-98 10:41am
c         write(iTrackFunction,"(I2,F7.0,F5.1,F7.4,1p,2E22.10)") 
c     &            WhichLimit,df, TrueSigma, alpha,a(i)+h(i)/2.0d0, FD
c         !call flush(iTrackFunction) ! 1-13-98 9:29pm
c
c$End If

c$If Defined (TrackFunctionCalls)
c    ! 1-10-98 11:23am It"s getting stuck with df=3,alpha=0.999, s=10 fo lower
c           write(*,*)  
c     &         WhichLimit,
c     &    "a_i+3h/2 Calling with x= ",a(i) + 3.0D0 * h(i) / 2.0D0
c$End If

       FE = TheFuncz(WhichLimit,a(i) + 3.0D0 * h(i) / 2.0D0, TrueMu,
     &           TrueSigma, lambda, df, alpha, FunczTolerance,ResultTol)
c$If Defined (TrackFunctionCalls)
c       NumCalls=NumCalls+1 ! 1-9-98, 11:15pm
c        write(*,"(I5,F7.0, F5.1, F8.5, I7)") 
c     &            WhichLimit,df, TrueSigma, alpha, NumCalls
c       write(*,"(A10,1p,2E22.10)") 
c     &        "       ",a(i) + 3.0D0 * h(i) / 2.0D0, FE ! 1-10-98 10:41am
c       write(iTrackFunction,"(I2,F7.0,F5.1,F7.4,1p,2E22.10)") 
c     &  WhichLimit,df, TrueSigma, alpha,a(i) + 3.0D0 * h(i) / 2.0D0, FE
c         !call flush(iTrackFunction) ! 1-13-98 9:29pm
c
c$End If
       S1 = h(i) * (FA(i) + 4.0D0 * FD + FC(i)) / 6.0D0
       S2 = h(i) * (FC(i) + 4.0D0 * FE + FB(i)) / 6.0D0

       v1 = a(i)
       v2 = FA(i)
       v3 = FC(i)
       v4 = FB(i)
       v5 = h(i)
        
c commented out 1-13-98 6:13pm
c        sigg1 =TrueSigma * dsqrt(ChiInverse(v1, df,1d-14) / df)
c        sigg2 =TrueSigma * dsqrt(ChiInverse(v1+v5, df,1d-14) / df)
c        sigg3 =TrueSigma * dsqrt(ChiInverse(v1+v5+v5, df,1d-14) / df)

c        write(*,"(1p,3E22.15)") v1,v1+v5,v1+v5+v5
c        write(*,"(1p,3E22.15)") v2,v3,v4
c        write(*,"(1p,E22.15)") sigg1
c        write(*,"(1p,E22.15)") sigg2
c        write(*,"(1p,E22.15)") sigg3
c        write(*,*)
c        read(*,*)

c        If (sigg1.ge.sigg2) then
c           write(*,*) "sigg1>sigg2!"
c           read(*,*)
c        End If

c        If (sigg1.ge.sigg3) then
c           write(*,*) "sigg1>sigg3!"
c           read(*,*)
c        End If


       v6 = Tol(i)
       v7 = s(i)
       v8 = L(i)

       i = i - 1

       !write(*,*) ! 1-4-98,11:21pm
       !write(*,*) "s1,s2,s1+s2,v7"
       !write(*,*) s1,s2,s1+s2,v7
       !write(*,*)

       If (DAbs(S1 + S2 - v7) .le. v6) Then

c$If Defined(UseOldVerifyAdapQuadMethod)    
c             APP = APP + S1 + S2
c             !write(*,*) "APP is ",APP
c$Else
             APP=APP+(16.0d0*(S1+S2)-V7)/15.0d0 !1-20-98 7:32pm
c$End If

       Else
   
           !If (v8 .ge. N-2) Then
           If (i .ge. N-2) Then
              !! level exceeded
              write(*,*) "Level exceeded! i, L(i) are",i,L(i)
              write(*,"(A14,1p,E14.6)")
     &                   " Sigma is ",TrueSigma
              AdapQuadforCriticalP = APP
              Return
           Else


              i = i + 1
              !write(*,*) "i is ",i
              !write(*,*) abs(S1+S2-v7)/v6

              a(i) = v1 + v5
              FA(i) = v3
              FC(i) = FE
              FB(i) = v4

              h(i) = v5 / 2.0D0

              If (dabs(h(i)/a(i)).lt.1d-12) then
                !write(*,*) "Something""s potentially wrong.  a(i)~b(i)"
       !" a,F(a); c,F(c),b,F(b) ",       1-4-98, 11:02pm
      write(*,*)
        write(7,"(1p,6E12.5)") v1,v2,v1+v5,v3,v1+2.0*v5,v4  !       1-4-98, 11:02pm
      write(*,"(A6,1p,2E22.15)")
     &     " a,fa",v1,v2  !       1-5-98, 10:17pm
      write(*,"(A6,1p,2E22.15)")
     &   " c,fc",v1+v5,v3  !       1-5-98, 10:17pm
      write(*,"(A6,1p,2E22.15)")
     &   " b,fb",v1+2.0*v5,v4        !       1-5-98, 10:17pm
       write(*,*)  
         
       write(*,"(A14,1p,2E22.15)") " S1,S2", S1,S2               !1-5-98
       write(*,"(A12  ,2E22.15)") " S1+S2, v7",S1+S2,v7 ! 1-5-98
       write(*,"(A16 ,2e22.15)") " error, tol(i) ", 
     &                     DAbs(S1 + S2 - v7), v6

       ! 1-6-98, 12:50am read(*,*)
                !stop
                ! Got rid of stop statement.  BFL, 1-3-98, 10:04pm
              End If



              Tol(i) = v6 / 2.0D0
              s(i) = S2
              L(i) = v8 + 1.0D0

              sigg =TrueSigma * dsqrt(ChiInverse(a(i), df,1d-14) / df)

c              write(*,"(I4,1p,5E14.4)")
c     &          i,sigg !11:22pm, ,v1,v5,v3,v4 ! bfl,1-4-98,9:27pm


              i = i + 1

              If (i.gt.MaxLevelUsed) MaxLevelUsed=i

              a(i) = v1

              FA(i) = v2
              FC(i) = FD
              FB(i) = v3
              h(i) = h(i - 1)
              Tol(i) = Tol(i - 1)
              s(i) = S1
              L(i) = L(i - 1)
           End If
        
           End If
       End Do

       AdapQuadforCriticalP = APP

       End !Function AdapQuadforCriticalP
c----------------------------------------------------------------------

       Real*8 Function PQDiff(p, q,TrueMu, TrueSigma,lambda,
     &           df, alpha,Tolerance,ResultTol)

       Real*8 p, q,TrueMu, TrueSigma,lambda,
     &           df, alpha,Tolerance,ResultTol

       Real*8 m,s,TrueValue
       Real*8 PQLimit,NormInverse,ChiInverse
       Real*8 UpperConfLimit

       ! get sample mean:
       m = NormInverse(p, TrueMu, TrueSigma / dsqrt(df + 1.0d0))
       s = TrueSigma * dsqrt(ChiInverse(q, df,1d-15) / df)       !-14->-15 1-6-98, 11:55pm

       write(*,*) "in pqdiff,m,s are ",m,s

       PQLimit = UpperConfLimit(m, s, lambda, df, alpha,
     &          Tolerance,ResultTol)

       TrueValue = TrueMu + lambda * TrueSigma * TrueSigma

       PQDiff = PQLimit - TrueValue
    
    
       End !Function PQDiff
c----------------------------------------------------------------------

       Real*8 Function CriticalPNew(WhichLimit,
     &         q,TrueMu, TrueSigma, lambda,
     &         df, alpha, Tolerance,ResultTol)

       Integer WhichLimit
       Real*8 q,TrueMu, TrueSigma, lambda,
     &         df, alpha, Tolerance,ResultTol
       Real*8 q_1,q_2,PQDiff,q_next

       Real*8 p_1
       Real*8 p_2
       Real*8 P_next
       Logical NotDone
       Integer ItNum
       Real*8 Compare,FasterCriticalP

       CriticalPNew = FasterCriticalP(
     &         WhichLimit,
     &         q,TrueMu, TrueSigma, lambda,
     &         df, alpha,Tolerance,ResultTol)

       Return

       NotDone = .True.
       ItNum=0

       !p_1=-2
       !If (p_1.lt.0) then
       !
       !   CriticalPNew=q*q*q
       !
       !Else

       ! First find an interval that contains the root
       p_1 = 0.5
       q_1 = PQDiff(p_1, q, TrueMu,
     &              TrueSigma, lambda, df, alpha, Tolerance,ResultTol)

       Do While ((q_1 .gt. 0.0d0) .and. (p_1 .gt.Tolerance))
       p_1 = p_1 / 2.0D0
       q_1 = PQDiff(p_1, q, TrueMu,
     &              TrueSigma, lambda, df, alpha, Tolerance,ResultTol)
       End Do

       If (p_1 .lt. Tolerance) Then
         CriticalPNew = p_1
         NotDone = .False.
       End If

       p_2 = 0.5D0
       q_2 = PQDiff(p_2, q, TrueMu,
     &              TrueSigma, lambda, df, alpha, Tolerance,ResultTol)

       Do While ((q_2 .lt. 0) .And. (p_2 .lt. 1.0D0 - Tolerance))
       p_2 = 1 - (1 - p_2) / 2
       q_2 = PQDiff(p_2, q, TrueMu,
     &            TrueSigma, lambda, df, alpha, Tolerance,ResultTol)
       End Do

       If (p_2 .gt. 1 - Tolerance) Then
         CriticalPNew = p_2
         NotDone = .False.
       End If

       If (((q_1 * q_2) .gt. 0) .And. NotDone) Then ! error
          CriticalPNew = -99
       Else
   
       Do While (NotDone)

       ItNum = ItNum + 1
       P_next = (p_1 + p_2) / 2.0D0

       q_next = PQDiff(P_next, q, TrueMu,
     &            TrueSigma, lambda, df, alpha, Tolerance,ResultTol)

        !write(*,*) "ItNum,p_next,q_next are ",ItNum,p_next,q_next

       If ((DAbs(q_next) .lt. Tolerance) .Or. (ItNum .gt. 100)) Then

       NotDone = .False.
c        write(*,"(A25,1p,3E12.4,0p,I3)")
c     &    " q, p,Val(=0?),ItNum: "
c     &     ,q,P_Next,q_next,ItNum

       CriticalPNew = P_next



       Else

       If ((q_next * q_1) .gt. 0) Then

       p_1 = P_next
       q_1 = q_next

       Else
       p_2 = P_next
       q_2 = q_next

       End If

       End If

       End Do

       End If

       !End If ! TESTING!

         write(*,*) "Old,New ",CriticalPNew,Compare
         !read(*,*)

       End !Function CriticalPNew
c----------------------------------------------------------------------


c       Real*8 Function UpperConfLimit(
c     &         m , s, lambda,nu,alpha, Tolerance,ResultTol )
       Real*8 Function UpperConfLimit(
     &         m , s, lambda,nu,alpha,TheTol,ResTol )          ! 1-14-98 4:11pm

       Real*8       m , s, lambda,nu,alpha, TheTol,ResTol       ! 1-14-98 4:11pm


       Integer WhichLimit
       Real*8 TheH
       Real*8 TheLimit
       Real*8 TheTime
       Integer ItNum
       Include "control.cmn" ! 1-14-98 4:11pm

       Tolerance=TheTol   ! 1-14-98 4:11pm
       ResultTol=ResTol   ! 1-14-98 4:11pm

       WhichLimit = 1

c Calling OneTail since this takes all arguments
c  now.  10-18-1999
c       Call OneTailConfLimit(WhichLimit, m, s, nu,
c     &            alpha, lambda, nu + 1.0D0,
c     &            TheH, TheLimit, TheTime, ItNum, Tolerance,ResultTol)


       Call OneTail(WhichLimit, m, s, nu,
     &            alpha, lambda, nu + 1.0D0,
     &            ArgTop, 
     &            Tolerance, 
     &            ResultTol,
     &            NumIt,
     &            TheH, TheLimit, 
     &            TheTime, ItNum)


       UpperConfLimit = TheLimit

       End !Function "UpperConfLimit
c----------------------------------------------------------------------

       Real*8 Function TwoTailforVerify(
     &            WhichLimit,   ! 1=Lower,2=Upper
     &            m,s,nu,alpha,lambda,TheTol,ResTol)


       Integer*4 ItNum1,ItNum2,WhichLimit
       Real*8 ResTol,TheTol, m,
     &                s,nu,
     &             alpha,
     &            lambda,
     &            gammasq,
     &            LowerLimit,
     &            UpperLimit,
     &            TheTime,
     &            LowerGuess1,LowerGuess2,UpperGuess1,UpperGuess2

       Real*8 UpperTheH, LowerTheH

       include "control.cmn"

       Tolerance=TheTol
       ResultTol=ResTol
       ArgTop=800.0d0
       NumIt=200

c above here
       gammasq=nu+1.0d0
       Call TwoTail(
     &                m,
     &                s,
     &              nu,
     &             alpha,
     &            lambda,
     &            gammasq,
     &	     ArgTop, 
     &     Tolerance, 
     &     ResultTol,
     &         NumIt,
     &            LowerLimit,
     &            LowerTheH,
     &            UpperLimit,
     &            UpperTheH,
     &            TheTime,
     &            ItNum1,ItNum2         )


c      &            LowerGuess1,LowerGuess2,UpperGuess1,UpperGuess2,

            If (WhichLimit.eq.1) then

                 TwoTailforVerify = LowerLimit !TheH

            Else

                 TwoTailforVerify = UpperLimit !TheH

            End If

            End ! Function TwoTailforVerify

       Real*8 Function TwoTailPQDiff(
     &          WhichLimit,p, q,TrueMu, TrueSigma,lambda,
     &           df, alpha,Tolerance,ResultTol)

       Character*8 LimitName(2)
       Integer WhichLimit
       Real*8 p, q,TrueMu, TrueSigma,lambda,
     &           df, alpha,Tolerance,ResultTol

       Real*8 m,s,TrueValue
       Real*8 PQLimit,NormInverse,ChiInverse
       Real*8 TwoTailforVerify  !UpperConfLimit

       LimitName(1)= " Lower"
       LimitName(2)= " Upper"


c        write(*,*) "In diff; p,q are ",p,q
       ! get sample mean:
       m = NormInverse(p, TrueMu, TrueSigma / dsqrt(df + 1))
       s = TrueSigma * dsqrt(ChiInverse(q, df,1d-14) / df)
c        write(*,"(A8,A16,F5.0,1p,2E14.6)")
c     &       LimitName(WhichLimit),
c     &       " df,q,s are ",df,q,s

       PQLimit = 
     &           TwoTailforVerify(
     &            WhichLimit,   ! 1=Lower,2=Upper
     &            m,s,df,alpha,lambda,Tolerance,ResultTol)

cUpperConfLimit(m, s, lambda, df, alpha, Tolerance)
       !write(*,*) "TwoTail is ",PQLimit
       TrueValue = TrueMu + lambda * TrueSigma * TrueSigma

c        write(*,"(A17,6F10.4)")
c     &   " p,q,m,s,Lim,Val ",p,q,m,s,PQLimit,TrueValue
c        write(7,"(A17,6F10.4)")
c     &   " p,q,m,s,Lim,Val ",p,q,m,s,PQLimit,TrueValue

       TwoTailPQDiff = PQLimit - TrueValue
    
    
       End !Function TwoTailPQDiff
c----------------------------------------------------------------------

       Real*8 Function TwoTailCriticalP(
     &         WhichLimit,q,TrueMu, TrueSigma, lambda,
     &         df, alpha, Tolerance,ResultTol)

       Integer WhichLimit
       Real*8 q,TrueMu, TrueSigma, lambda,
     &         df, alpha, Tolerance,ResultTol
       Real*8 Temp_p,q_1,q_2,TwoTailPQDiff,q_next
       Real*8 CriticalPNew

       Real*8 p_1
       Real*8 p_2
       Real*8 P_next
       Logical NotDone
       Integer ItNum
       Real*8 CompareCriticalP,FasterTwoTailCriticalP
       Character*8 LimitName(2)

       LimitName(1)= " Lower"
       LimitName(2)= " Upper"

       TwoTailCriticalP = FasterTwoTailCriticalP(
     &          WhichLimit,q,TrueMu, TrueSigma,lambda,
     &           df, alpha,Tolerance,ResultTol)

       Return ! that"s it... BFL, 3-31-96

       write(*,*) "Compare is ",CompareCriticalP

       NotDone = .True.
       ItNum=0

       !p_1=-2
       !If (p_1.lt.0) then
       !
       !   CriticalPNew=q*q*q
       !
       !Else


c        write(*,*) "Getting guesses..."
       ! First find an interval that contains the root
       If (WhichLimit.eq.1) then
         Temp_p = CriticalPNew(WhichLimit,
     &              q,TrueMu, TrueSigma, lambda,
     &              df, (1.0d0-alpha)/2.0d0, Tolerance,ResultTol)
       Else
         Temp_p = CriticalPNew(WhichLimit,
     &              q,TrueMu, TrueSigma, lambda,
     &              df, 1.0-(1.0d0-alpha)/2.0, Tolerance,ResultTol)
       End If


       p_1 =  Temp_p
       !write(*,*) "using p_1=0.5"
       p_1=0.5

       q_1 = TwoTailPQDiff(WhichLimit,p_1, q, TrueMu,
     &              TrueSigma, lambda, df, alpha, Tolerance,ResultTol)

c        write(*,"(A30,1p,3E12.4)")
c     &     "1st g:q,p_1,q_1 (q_1<0?) ",q,p_1,q_1

       Do While ((q_1 .gt. 0.0d0) .and. (p_1 .gt.Tolerance))
       p_1 = p_1 / 2.0D0
       !write(*,*) "Calling diff; p_1,q are ",p_1,q
       q_1 = TwoTailPQDiff(WhichLimit,p_1, q, TrueMu,
     &              TrueSigma, lambda, df, alpha, Tolerance,ResultTol)

c        write(*,"(A30,1p,3E12.4)")
c     &     "q,p_1,q_1 (q_1<0?) ",q,p_1,q_1

       End Do

       If ((p_1 .lt. Tolerance).and.(q_1.ge.0)) Then
         ! We couldn"t even find a small enough p_1 so that
         ! q_1<0.  Thus we get out setting result to p_1
c          write(*,"(A25,1p,3E12.4)")
c     &     "Leaving; q,p_1,q_1 are ",q,p_1,q_1
         TwoTailCriticalP = p_1
         NotDone = .False.
       Else
c          write(*,"(A30,1p,3E12.4)")
c     &     "Got 1st guess; q,p_1,q_1 are ",q,p_1,q_1
       End If

       p_2 = Temp_p
c        write(*,*) "using p_2=0.5"
       p_2=0.5

       q_2 = TwoTailPQDiff(WhichLimit,p_2, q, TrueMu,
     &              TrueSigma, lambda, df, alpha, Tolerance,ResultTol)

c        write(*,"(A30,1p,3E12.4)")
c     &     "2ndG:q,p_2,q_2 (q_2>0?) ",q,p_2,q_2

       Do While ((q_2 .lt. 0) .And. (p_2 .lt. 1.0D0 - Tolerance))
       p_2 = 1 - (1 - p_2) / 2
       q_2 = TwoTailPQDiff(WhichLimit,p_2, q, TrueMu,
     &            TrueSigma, lambda, df, alpha, Tolerance,ResultTol)
c        write(*,"(A30,1p,3E12.4)")
c     &     "q,p_2,q_2 (q_2>0?) ",q,p_2,q_2
       End Do

       If ((p_2 .ge. 1.0d0 - Tolerance).and.(q_2.le.0)) Then
         ! This means that p_2~1

         !If (abs(q_2) .lt. Tolerance) Then
c          write(*,"(A25,1p,3E12.4)")
c     &     "Leaving; q,p_2,q_2 are ",q,p_2,q_2
         TwoTailCriticalP = p_2
         NotDone = .False.
       Else
c          write(*,"(A30,1p,3E12.4)")
c     &     "Got 2nd guess; q,p_2,q_2 are ",q,p_2,q_2

       End If

       If (((q_1 * q_2) .gt. 0) .And. NotDone) Then ! error
          TwoTailCriticalP = -99
          write(*,*) "Error! q1*q2>0 and NotDone!"
          write(*,*) "q,df are ",q,df

          Do While (q.gt.0)

          write(*,*) "Enter q,p_2"
          read(*,*) q,p_2
          write(*,*) "TwoTailPqDiff is ",
     &           TwoTailPQDiff(WhichLimit,p_2, q, TrueMu,
     &              TrueSigma, lambda, df, alpha, Tolerance,ResultTol)

          End Do

          stop
       Else


       write(*,*) "Starting p loop..."
       Do While (NotDone)

       ItNum = ItNum + 1
       P_next = (p_1 + p_2) / 2.0D0

       q_next = TwoTailPQDiff(WhichLimit,P_next, q, TrueMu,
     &            TrueSigma, lambda, df, alpha, Tolerance,ResultTol)

c        write(*,"(A20,I4,2F10.4)")
c     &     "ItNum,p_next,q_next are ",ItNum,p_next,q_next

       !write(*,*) "Guess,New ",P_Next,CompareCriticalP

       If ((DAbs(q_next) .lt. Tolerance) .Or. (ItNum .gt. 200)) Then

       NotDone = .False.
c        write(*,"(A25,1p,3E12.4, 0p,I4)")
c     &     " q,p,Val(=0?),ItNum "
c     &     ,q,P_Next,q_next,ItNum

       TwoTailCriticalP = P_next


        write(*,*) "Old -New for "//LimitName(WhichLimit),
     &              P_Next-CompareCriticalP

        !read(*,*)

       Else

       If ((q_next * q_1) .gt. 0) Then

       p_1 = P_next
       q_1 = q_next

       Else
       p_2 = P_next
       q_2 = q_next

       End If

       End If

       End Do

       End If

       !End If ! TESTING!


       End !Function TwoTailCriticalP
c----------------------------------------------------------------------

c----------------------------------------------------------------------
       Real*8 Function FasterTwoTailCriticalP(
     &          WhichLimit, q,TrueMu, TrueSigma,lambda,
     &           df, alpha,Tolerance,ResultTol)

       ! Hopefully, a much more efficient and faster way to calculate
       ! "CriticalP"; uses linearity of confidence limits in the sample
       ! mean.
       !
       ! B.F. Lyon, 3-31-96

       Character*8 LimitName(2)
       Integer WhichLimit
       Real*8 p, q,TrueMu, TrueSigma,lambda,
     &           df, alpha,Tolerance,ResultTol

       Real*8 m,s,TrueValue,z,GoalValue
       Real*8 PQLimit,NormInverse,ChiInverse,NormSCdf
       Real*8 TwoTailforVerify  !UpperConfLimit

       LimitName(1)= " Lower"
       LimitName(2)= " Upper"


c        write(*,*) "In diff; p,q are ",p,q
       ! get sample mean:
       !m = NormInverse(p, TrueMu, TrueSigma / dsqrt(df + 1))
       s = TrueSigma * dsqrt(ChiInverse(q, df,1.0d-15) / df)
c        write(*,"(A8,A16,F5.0,1p,2E14.6)")
c     &       LimitName(WhichLimit),
c     &       " df,q,s are ",df,q,s


       m=TrueMu  ! p=0.5

       PQLimit = !UpperConfLimit(m, s, lambda, df, alpha, Tolerance)
     &                TwoTailforVerify(
     &            WhichLimit,   ! 1=Lower,2=Upper
     &            m,s,df,alpha,lambda,Tolerance,ResultTol)

       !write(*,*) "TwoTail is ",PQLimit
c$If Defined(SpitOutIntegrand) 
c       !If (WhichLimit.eq.2) then
c       !   write(*,*) "TwoTail is ",PQLimit ! 1-6-98, 11:22pm
c       !end if
c$End If
       TrueValue = TrueMu + lambda * TrueSigma * TrueSigma

       GoalValue=TrueValue + TrueMu - PqLimit

       z = (GoalValue-TrueMu)/ (TrueSigma / dsqrt(df + 1.0d0))

       FasterTwoTailCriticalP = NormSCdf(z)

c     &       NormCdf(GoalValue,TrueMu, TrueSigma / dsqrt(df + 1))

c        write(*,"(A17,6F10.4)")
c     &   " p,q,m,s,Lim,Val ",p,q,m,s,PQLimit,TrueValue
c        write(7,"(A17,6F10.4)")
c     &   " p,q,m,s,Lim,Val ",p,q,m,s,PQLimit,TrueValue
c
c        TwoTailPQDiff = PQLimit - TrueValue
    
    
       End !Function FasterTwoTailCriticalP
c----------------------------------------------------------------------

c----------------------------------------------------------------------
       Real*8 Function FasterCriticalP(
     &         WhichLimit,
     &         q,TrueMu, TrueSigma, lambda,
     &         df, alpha,Tolerance,ResultTol)

       ! Hopefully, a much more efficient and faster way to calculate
       ! "CriticalP"; uses linearity of confidence limits in the sample
       ! mean.
       !
       ! B.F. Lyon, 4-5-96

       Integer WhichLimit
       Real*8 p, q,TrueMu, TrueSigma,lambda,
     &           df, alpha,Tolerance,ResultTol

       Real*8 m,s,TrueValue,z,GoalValue
       Real*8 PQLimit,NormInverse,ChiInverse,NormSCdf
       Real*8 UpperConfLimit


c$If Defined() 1-14-98 11:10pm
c       If (q.ge.1.0) then
c       write(*,*) "q is ",q
c       read(*,*)
c       end if
c commented out at 11:21pm
c$End If
c        write(*,*) "In diff; p,q are ",p,q
       ! get sample mean:
       !m = NormInverse(p, TrueMu, TrueSigma / dsqrt(df + 1))
       s = TrueSigma * dsqrt(ChiInverse(q, df,1.0d-15) / df)
       ! hangs if you use 1d-16, trying -16 for chiinverse, 1-14-98 11:19pm
c        write(*,"(A8,A16,F5.0,1p,2E14.6)")
c     &       LimitName(WhichLimit),
c     &       " df,q,s are ",df,q,s


       !write(*,*) "q,s ",q,s


c       If (q.ge.(1.0d0-2.6d-6)) then
c       FasterCriticalP=1.0d0
c        return
c       end if ! see if this is the problem with last few digits 1-14-98 11:38pm

       m=TrueMu  ! p=0.5

       PQLimit =
     & UpperConfLimit(m, s, lambda, df, alpha, Tolerance,ResultTol)

       TrueValue = TrueMu + lambda * TrueSigma * TrueSigma

       GoalValue=TrueValue + TrueMu - PqLimit

       z = (GoalValue-TrueMu)/ (TrueSigma / dsqrt(df + 1.0d0))

       FasterCriticalP = NormSCdf(z)

       End !Function FasterCriticalP
c----------------------------------------------------------------------
